#version 440 core

//#define LOCAL_SIZE 32

layout(local_size_x = LOCAL_SIZE) in;

// 16 KB at least supported by directx 11 GPUs (4096*sizeof(float) = 16 KB)
//#define SHARED_MEM_SIZE 4096

//shared float shared_mem[SHARED_MEM_SIZE];

layout(std430, binding = 0)
buffer Data {
    float data[]; // also SHARED_MEM_SIZE
};
layout(std430, binding = 1)
buffer outData {
    float outDataArray[]; // also SHARED_MEM_SIZE
};

float pow2(float x) { return x * x; }

void main()
{
    uint thread_id = gl_GlobalInvocationID.x;

    // Compute
    for(uint i = thread_id; i < SHARED_MEM_SIZE; i += LOCAL_SIZE)
    {
        float v = data[i];
        float diffSum = 0.0;

        for(uint j=0; j < SHARED_MEM_SIZE; j++){
            // version 1 broadcast
            diffSum += pow2(v- data[j]);
        }

        // write result back to global memory
        outDataArray[i] = diffSum / (SHARED_MEM_SIZE - 1); // average squared difference
    }
}
