#version 440 core

layout(local_size_x = LOCAL_SIZE) in;

//SHARED_MEM_SIZE hier = BUFFER_SIZE

layout(std430, binding = 0)
buffer Data {
    float data[]; 
};

layout(std430, binding = 1)
buffer outData {
    float outDataArray[];
};

float pow2(float x) { return x * x; }

void main()
{
    uint thread_id = gl_GlobalInvocationID.x;

    // Compute
    for(uint i = thread_id; i < SHARED_MEM_SIZE; i += LOCAL_SIZE)
    {
        float v = data[i];
        float diffSum = 0.0;

        // generalized with stride
        //uint stride=8;
        for(uint j=0; j< SHARED_MEM_SIZE; j+= STRIDE){
            for(uint s=0; s< STRIDE; s++)
                diffSum += pow2(v- data[(j+ thread_id* STRIDE+ s)% SHARED_MEM_SIZE]);
        }

        // write result back to global memory
        outDataArray[i] = diffSum / (SHARED_MEM_SIZE - 1); // average squared difference
    }
}
